/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef FINDTOOLBAR_H
#define FINDTOOLBAR_H

#include <gtkmm/label.h>
#include <gtkmm/box.h>
#include <gtkmm/button.h>
#include <gtkmm/image.h>
#include <gtkmm/entry.h>
#include <gtkmm/checkbutton.h>

class FindToolbar : public Gtk::HBox
{
public:
  FindToolbar();

  Gtk::Button* get_close();
  Gtk::Button* get_find();
  Gtk::Button* get_replace();
  Gtk::Entry* get_text();
  
  void show_error(bool);
  bool search_files_is_active();

private:
  Gtk::Label *label_find, *label_error;
  Gtk::Entry *find_text;
  Gtk::Button *button_find, *button_close, *button_replace;
  Gtk::Image *image_close, *image_error;
  Gtk::CheckButton *search_files;
};

#endif
