/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "inputdialog.h"

// Default constructor of the InputDialog class that receives the label to
// ask of the user and the title of the dialog box.
InputDialog::InputDialog (Glib::ustring label_text, Glib::ustring title)
{
  dialog = this;   
  cancel = new Gtk::Button(Gtk::StockID("gtk-cancel"));
  ok = new Gtk::Button(Gtk::StockID("gtk-ok"));
  label = new Gtk::Label(label_text);
  entry = new Gtk::Entry();
  hbox = new Gtk::HBox(false, 0);
    
  ok->set_flags(Gtk::CAN_DEFAULT);
  hbox->set_border_width(10);
  hbox->set_spacing(10);
  hbox->pack_start(*label, Gtk::PACK_SHRINK);
  hbox->pack_start(*entry);
  
  dialog->get_vbox()->set_homogeneous(false);
  dialog->get_vbox()->set_spacing(0);
  dialog->get_vbox()->pack_start(*hbox);
  dialog->set_title(title);
  dialog->set_modal(false);
  dialog->property_window_position().set_value(Gtk::WIN_POS_NONE);
  dialog->set_resizable(false);
  dialog->property_destroy_with_parent().set_value(false);
  dialog->set_has_separator(true);
  dialog->add_action_widget(*cancel, -6);
  dialog->add_action_widget(*ok, -5);
  
  dialog->show_all_children();
  dialog->show();
}

// Destroy all of the widgets
InputDialog::~InputDialog()
{
  delete cancel;
  delete ok;
  delete label;
  delete entry;
  delete hbox;
}

// Return the text specified by the user
Glib::ustring InputDialog::get_entry_text()
{ return entry->get_text();
}
