/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "outputterminal.h"

OutputTerminal::OutputTerminal()
{
  int value;
  
  terminal = vte_terminal_new();
  value = vte_terminal_fork_command (VTE_TERMINAL(terminal), 
          "/bin/bash", NULL, NULL, NULL, FALSE, FALSE, FALSE);
  vte_terminal_set_size(VTE_TERMINAL(terminal), 80, 250);
  vte_terminal_set_font_from_string(VTE_TERMINAL(terminal), "Monospace 10");
  GTK_WIDGET_SET_FLAGS(VTE_TERMINAL(terminal), Gtk::CAN_FOCUS);
  // GtkAdjustment *vte_terminal_get_adjustment(VteTerminal *terminal);
  
  swin = new Gtk::ScrolledWindow();
  swin->set_policy(Gtk::POLICY_NEVER, Gtk::POLICY_AUTOMATIC);
  swin->add(*(Glib::wrap(terminal, false)));
  gtk_widget_show(terminal);
  swin->show();
}

void OutputTerminal::run_command(Glib::ustring command)
{ vte_terminal_feed_child(VTE_TERMINAL(terminal), command.c_str(), command.length());
}

void OutputTerminal::grab_focus()
{ gtk_widget_grab_focus(terminal);
}

GtkWidget* OutputTerminal::get_terminal()
{ return terminal;
}

Gtk::ScrolledWindow* OutputTerminal::get_swin()
{ return swin;
}
