/***************************************************************************
 *   Copyright (C) 2005 by Andrew Krause                                   *
 *   Based on work by The gtkmm Development Team                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef SOURCELANGUAGESMANAGER_H
#define SOURCELANGUAGESMANAGER_H

#include <glibmm.h>
#include "sourceview/sourcelanguage.h"

typedef struct _GtkSourceLanguagesManager GtkSourceLanguagesManager;
typedef struct _GtkSourceLanguagesManagerClass GtkSourceLanguagesManagerClass;

namespace Gtk
{ class SourceLanguagesManager_Class; 
}

namespace Gtk
{
  class Widget;

  class SourceLanguagesManager : public Glib::Object
  {
  public:
    typedef SourceLanguagesManager CppObjectType;
    typedef SourceLanguagesManager_Class CppClassType;
    typedef GtkSourceLanguagesManager BaseObjectType;
    typedef GtkSourceLanguagesManagerClass BaseClassType;

    SourceLanguagesManager();
    virtual ~SourceLanguagesManager();
  
    explicit SourceLanguagesManager(const Glib::ConstructParams& construct_params);
    explicit SourceLanguagesManager(GtkSourceLanguagesManager* castitem);
  
    static GType get_type()      G_GNUC_CONST;
    static GType get_base_type() G_GNUC_CONST;

    GtkSourceLanguagesManager*       gobj()       { return reinterpret_cast<GtkSourceLanguagesManager*>(gobject_); }
    const GtkSourceLanguagesManager* gobj() const { return reinterpret_cast<GtkSourceLanguagesManager*>(gobject_); }

    const GSList* get_available_languages();
    Gtk::SourceLanguage* get_language_from_mime_type(const Glib::ustring mime_type);
    const GSList* get_lang_files_dirs();

  private:
    friend class SourceLanguagesManger_Class;
    static CppClassType sourcelanguagesmanager_class_;

    SourceLanguagesManager(const SourceLanguagesManager&);
    SourceLanguagesManager& operator=(const SourceLanguagesManager&);
  };
}

namespace Glib
{ Glib::RefPtr<Gtk::SourceLanguagesManager> wrap(GtkSourceLanguagesManager* object, bool take_copy = false);
}

#endif
